import { Component, OnInit, TemplateRef } from '@angular/core';
import { FormGroup, Validators, FormBuilder } from '@angular/forms';
import { BsModalRef, ModalOptions, BsModalService } from 'ngx-bootstrap';
import { Router } from '@angular/router';
import { CommondialogComponent } from 'src/app/Shared/commondialog/commondialog.component';
import { ToastrService } from 'ngx-toastr';
import { DialogService } from 'ng2-bootstrap-modal';
import { AppUrl } from './appurl';
import { AppurlService } from './appurl.service';

@Component({
  selector: 'app-appurl',
  templateUrl: './appurl.component.html',
  styleUrls: ['./appurl.component.css']
})
export class AppurlComponent implements OnInit {
  sendMenuId: number;
  sendPageName = 'AppUrl';
  // action rights
  _menuId: any;
  _actionRights: any;
  readOnly = false; add = false; edit = false; delete = false;
  appurlForm: FormGroup;
  appurls: AppUrl[] = [];
  appurlsactive: AppUrl[] = [];
  appurl: AppUrl;
  deleteResult: boolean;
  postresult: boolean;
  putDResult: boolean;
  appurlModalRef: BsModalRef;
  operation: string;
  userid: number;
  appurlid: number;
  submitted = false;
  active: number;
  unamePattern: string;
  confmsg: string;
  p = 1; searchText: string;
  itemsPerPage = 10;
  config: ModalOptions = {
    backdrop: 'static',
    keyboard: false,
    animated: true,
    class: 'modal-dialog-centered',
    ignoreBackdropClick: true
  };
  showall = true;
  showallstatus = false;
  key = 'appurl'; // set default
  reverse = false;
  actionRights: any;
  constructor(private router: Router, private toastr: ToastrService, private dialogService: DialogService,
    private formBuilder: FormBuilder, private modalService: BsModalService, private appurlservice: AppurlService) {
     // get rights for the logged in user for the particular component
     if (this.router.getCurrentNavigation().extras.state !== undefined) {
      localStorage.setItem('AppUrl_menuid', this.router.getCurrentNavigation().extras.state.menuid);
      localStorage.setItem('AppUrl_userRights', this.router.getCurrentNavigation().extras.state.action);
      this.actionRights = [];
      this.actionRights = this.router.getCurrentNavigation().extras.state.action;
    } else {
      this.actionRights = [];
      this.actionRights = localStorage.getItem('AppUrl_userRights');
    }
  }

  ngOnInit() {
    this.appurlForm = this.formBuilder.group({
      appurlid: [''],
      appurl: ['', [Validators.required]],
      active: ['']
    });
    this.searchText = '';
    this.getAll();
    // for action rights
    this.getUserRights();
  }

  getactiveinactive(showallp) {
    this.appurlsactive = [];
    this.showall = showallp;
    this.showallstatus = showallp;
    if (this.showall === true) {
      this.showall = false;
      this.appurls.forEach(data => {
        if (data.active === 1) {
          this.appurlsactive.push(data);
        }
      });
      this.appurls = [];
      this.appurls = this.appurlsactive;
    } else {
      this.showall = true;
      this.appurls = [];
      this.getAll();
    }
  }

  // function to get user rights
  getUserRights() {
    const btnToEnable = JSON.parse(this.actionRights);
    if (btnToEnable.length > 0) {
      this.readOnly = true;
      btnToEnable.forEach(d => {
        if (d !== undefined) {
          if (d === 2) {
            this.add = true;
          } else if (d === 3) {
            this.edit = true;
          } else if (d === 4) {
            this.delete = true;
          }
        }
      });
    }
  }

  clearForm() {
    this.appurlModalRef.hide();
  }

  sort(key) {
    this.key = key;
    this.reverse = !this.reverse;
  }


  getAll() {
    this.appurls = [];
    this.appurlsactive = [];
    this.appurlservice.Get().subscribe(res => {
      if (res[0] != null && res[0] !== undefined) {
        this.appurls = JSON.parse(res[0]);
        if (this.showallstatus === true) {
          this.appurls.forEach(data => {
            if (data.active === 1) {
              this.appurlsactive.push(data);
            }
          });
          this.appurls = [];
          this.appurls = this.appurlsactive;
        }
      }
    }, error => { this.toastr.error('Error while getting data'); });

  }

  get g() { return this.appurlForm.controls; }

  Post(appurl: AppUrl) {

    this.submitted = true;

    if ((appurl.appurl.trim() === undefined) || (appurl.appurl.trim() === '')) {
      this.toastr.error('AppUrl should not be empty');
      return;
    }

    let msg = null;

    this.userid = +localStorage.getItem('userid');
    appurl.appurl = appurl.appurl.trim();
    if (this.operation === 'add') {

      appurl.createdby = this.userid;
      msg = 'Record Added Successfully';
      this.appurlservice.Post(appurl).subscribe(res => {
        if (res.status === 200) {
          if (res !== undefined) {
            if (res.body !== 0) {
              this.appurlModalRef.hide();
              this.getAll();
              this.toastr.success('Data added successfully');
              this.clearForm();
            } else { this.toastr.warning('Record already exists.'); }
          }
        }
      },
        error => {
          this.toastr.error('Error while doing the operation');
          this.postresult = false;
        });
    } else if (this.operation = 'update') {
           appurl.updatedby = this.userid;
      msg = 'Record updated successfully';
      this.appurlservice.Put(appurl).subscribe(res => {
        if (res.status === 200) {
          if (res !== undefined) {
            if (res.body !== 0) {
              this.appurlModalRef.hide();
              this.getAll();
              this.toastr.success('Data updated successfully');
              this.clearForm();
            } else { this.toastr.warning('Record already exists.'); }
          }
        }
      },
        error => {
          this.toastr.error('Error while doing the operation');
          this.postresult = false;
        });
    }
    this.submitted = false;
  }

  ChangeActive(e) {
    if (e.currentTarget.checked) {
      this.appurlForm.controls['active'].setValue(1);
    } else {
      this.appurlForm.controls['active'].setValue(0);
    }
  }

  OpenConfirmTemplate(appurl) {
    if (appurl.active === 0) {
      this.confmsg = 'activate';
    } else {
      this.confmsg = 'deactivate';
    }
    this.dialogService.addDialog(CommondialogComponent,
      {
        title: 'Please Confirm',
        message: 'Are you sure you want to ' + this.confmsg + ' this record ?',
        hclass: 'modelsuccess',
        oktext: 'Yes',
        canceltext: 'No',
        okshow: true,
        cancelshow: true
      }).subscribe((isConfirmed) => {
        if (isConfirmed) {
          this.appurl = appurl;

          this.Delete();

        }

      });

  }

  Delete() {
    let msg;
    if (this.appurl.active === 0) {
      this.appurl.active = 1;
      msg = 'Record activated successfully';
    } else {
      this.appurl.active = 0;
      msg = 'Record deactivated successfully';
    }
    this.userid = +localStorage.getItem('userid');
    this.appurl.updatedby = this.userid;
    this.appurlservice.Delete(this.appurl).subscribe(res => {
      this.toastr.success(msg);
      this.getAll();
    },
      error => { this.deleteResult = false; });

  }

  hidePopup() {
    this.appurlModalRef.hide();
  }

  openAppUrlModal(template: TemplateRef<any>, type, appurl?: AppUrl) {

    this.operation = type;

    if (type === 'update') {
      this.appurlForm.controls['appurlid'].setValue(appurl.appurlid);
      this.appurlForm.controls['appurl'].setValue(appurl.appurl);
      this.appurlForm.controls['active'].setValue(appurl.active);
      this.appurl = appurl;
    }
    if (type === 'add') {
      this.appurlForm.controls['appurlid'].setValue(0);
      this.appurlForm.controls['appurl'].setValue('');
      this.appurlForm.controls['active'].setValue(1);
    }
    this.appurlModalRef = this.modalService.show(template, this.config);

    const aa = document.getElementsByClassName('modal-content');
    aa[0].classList.remove('modal-content');

  }

}
